import {Component, EventEmitter, Input, OnInit, Output} from '@angular/core';
import {
  ProductTransitionEditorComponent
} from "../transition-editor/product-transition-editor/product-transition-editor.component";
import {ProductGamesystem} from "../../../project/game-model/gamesystems/ProductGamesystem";
import {SimpleGamesystem} from "../../../project/game-model/gamesystems/SimpleGamesystem";
import {TemplateElement} from "../../../project/game-model/templates/TemplateElement";



@Component({
  selector: 'app-product-gamesystem-editor',
  templateUrl: './product-gamesystem-editor.component.html',
  styleUrl: './product-gamesystem-editor.component.scss'
})
export class ProductGamesystemEditorComponent implements OnInit{

  @Input() gamesystem: ProductGamesystem | undefined
  @Input() templateElement: TemplateElement | undefined
  @Output("onOpenGamesystemEditor") openGamesystemEditorEmitter = new EventEmitter<SimpleGamesystem>();

  ngOnInit() {
  }

  onOpenGamesystemEditor(gamesystem: SimpleGamesystem) {
    this.openGamesystemEditorEmitter.emit(gamesystem);
  }
}
